<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Group_Pricing_Model extends CI_Model {
	function __construct() 
  {
    parent::__construct();
  }
  
  
  
  
  
   public function get_group_list()
  {
		$this->db->select('item_group_type.group_code,item_group_type.id');
		$this->db->from('item_group_type');
		//$this->db->where("item_group_type.status",1);
		
		$query = $this->db->get();
		return $query->result_array(); 
	
  }
  
  function get_all_product_by_group_id($id)
	{
		$this->db->select('product_id,product_name,book_year');
		$this->db->from('product');
		$this->db->where('item_group_id',$id);
		$query=$this->db->get();
		$data=array();
 
		//$data[0] = 'SELECT'; 
		foreach ($query->result() as $row)
		{
		$data[$row->product_id] = $row->product_name." - ".$row->book_year;
		}
		return ($data);
		
		
		
	}
	
	 function get_group_item_list_by_group_id($id)
	{
		$this->db->select('gpi.quantity,gpi.product_id,p.product_name,p.book_year');
		$this->db->from('group_pricing_items gpi');
		$this->db->join('product p','gpi.product_id=p.product_id','left');
		$this->db->where('gpi.grp_id',$id);
		$query=$this->db->get();
		return $query->result_array(); 
		
		
		
		
	}
  
  
  
  public function get_product_items($grp_id)
  {
	 
	  
		
		$this->db->select('group_pricing_items.quantity');
		$this->db->select('product.product_name,product.product_code');
		$this->db->from('group_pricing_items');
		$this->db->join('product','product.product_id=group_pricing_items.product_id','left');
		$this->db->where("group_pricing_items.grp_id",$grp_id);
		$this->db->group_by('group_pricing_items.grp_items_id');
		$query = $this->db->get();
		return $query->result_array(); 
	  
  }
  
  
  
  
  
  
	function get_products_suggestions($term) {
		$this->db->select('product'.'.*');
		$this->db->order_by("product_name", "asc");
		$this->db->where("product_name LIKE '%$term%' OR product_code LIKE '%$term%' OR product_oem_part_number LIKE '%$term%' OR product_part_no LIKE '%$term% AND product_group_status=0'");
		$this->db->limit(10,0);
		$query = $this->db->get('product');
		return $query->result_array();
	}
	function save_group($data_save){
		if($this->db->insert('group_pricing',$data_save)){
			return true;
			}else{
				return false;
				}
		}
	function save_group_item($data_item)
	{
			if($this->db->insert('group_pricing_items',$data_item)){
				return true;
				}else{
					return false;
					}
				}
	function insert_product_group_data($pro_item){
		if($this->db->insert('product',$pro_item)){
			return true;
			}else{
				return false;
				}
		}	
	function get_group_product_details_to_list(){
		$this->db->select('gp.*,sum(pci.quantity) as grp_quantity');
		$this->db->from('group_pricing gp');
		$this->db->join('group_pricing_items pci','gp.grp_id=pci.grp_id','left');
		$this->db->group_by('pci.grp_id');
		$query=$this->db->get();
		return $query->result_array();
		}	
	 function get_group_info($grp_id){
	    $this->db->select('*');
		$this->db->from('group_pricing');
		$this->db->where('grp_id',$grp_id);
		$query=$this->db->get();
		return $query->row_array();
	   }
	function get_group_items_info($grp_id){
	    $this->db->select('gpi.*,p.*');
		$this->db->from('group_pricing_items gpi');
		$this->db->join('product p','p.product_id=gpi.product_id','left');
		$this->db->where('gpi.grp_id',$grp_id);
		$query=$this->db->get();
		return $query->result_array();
	   }
	public function disableGroupData($grp_id)

	{    
     $data = array(
          'grp_status' => 0
     );
     $this->db->where('grp_id',$grp_id);
     if($this->db->update('group_pricing',$data))
     {return true;}else{return false;}
     }
   	public function disablegroupProductData($grp_id)

	{    
     $data = array(
          'product_status' => 0
     );
     $this->db->where('grp_id',$grp_id);
     if($this->db->update('product',$data))
     {return true;}else{return false;}
     }
	public function enableGroupData($grp_id)

	{    
     $data = array(
          'grp_status' => 1
     );
     $this->db->where('grp_id',$grp_id);
     if($this->db->update('group_pricing',$data))
     {return true;}else{return false;}
     }
   	public function enablegroupProductData($grp_id)

	{    
     $data = array(
          'product_status' => 1
     );
     $this->db->where('grp_id',$grp_id);
     if($this->db->update('product',$data))
     {return true;}else{return false;}
     }
	public function deleteGroupData($grp_id)

	{
     $this->db->where('grp_id',$grp_id);
     if($this->db->delete('group_pricing'))
     {return true;}
	 else{return false;}
     }
	public function deletegroupProductData($grp_id)

{    
     $this->db->where('grp_id',$grp_id);
     if($this->db->delete('product'))
     {return true;}else{return false;}
     } 
 public function deletegroupItemsData($grp_id)

{    
     $this->db->where('grp_id',$grp_id);
     if($this->db->delete('group_pricing_items'))
     {return true;}else{return false;}
     } 
public function get_product_details($product_id){
	$this->db->select('*');
	$this->db->from('product');
	$this->db->where('product_id',$product_id);
	$query=$this->db->get();
	return $query->row_array();
	}	 
public function get_group_product_details($grp_id){
	$this->db->select('p.*');
	$this->db->from('group_pricing_items g');
	$this->db->join('product p','p.product_id=g.product_id','inner');
	$this->db->group_by('p.product_id');
	$this->db->where('g.grp_id',$grp_id);
	$query=$this->db->get();
	return $query->row_array();
	}
public function delete_old_group_pricing_items($grp_id)
	{
		$this->db->where('grp_id', $grp_id);
		if($this->db->delete('group_pricing_items'))
		{ return true; 
		}else
		{ return false; 
		}
	}
public function update_group($data_update,$grp_id){
	$this->db->where('grp_id', $grp_id);
	if($this->db->update('group_pricing',$data_update))
	{ return true; 
	}
	else
	{ return false; 
	}
	}
public function update_product_group_data($pro_item_update,$product_id){
	$this->db->where('product_id', $product_id);
	if($this->db->update('product',$pro_item_update))
	{ return true; 
	}
	else
	{ return false; 
	}
	}
public function getSoldGroupQtyByWarehouseId($srh_warehouse_id,$product_id){
	$this->db->select_sum('quantity');
	$this->db->from('group_sale_items');
	$this->db->where('warehouse_id',$srh_warehouse_id);
	$this->db->where('product_id',$product_id);
	$query=$this->db->get();
	return $data['quantity']=$query->row()->quantity;	
		
	}					
}