<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Users extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->helper('url');
        $this->load->library('cart');
        $this->load->library('session');
        //$this->load->library('email');
        $this->load->model('cart_model');
        $this->load->model('User_Model');
        $this->load->model('Home_Model');
        $this->load->model('product_model');
        
        $this->load->helper('security');
        if(is_logged_in()){
            redirect(base_url());
        }
        date_default_timezone_set("asia/Colombo");
    }

    public function index() {
      
    }

    public function userLoginSingup(){
        $bodyClass = "page-template-default";
        $data['bodyClass'] =$bodyClass;
        $data['target'] =$this->input->get('target');
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
		$data['category_list'] = $this->Home_Model->get_category_for_homepage();    
        $this->load->view('user/login-and-register' , $data);

    }

    public function signup() {
        $this->load->library('form_validation'); //form validation lib		
		//validations
		$this->form_validation->set_rules('email', 'User Name or E-mail', 'trim|required|min_length[4]|max_length[40]|xss_clean');
		$this->form_validation->set_rules('password', 'Password', 'trim|required|min_length[4]|max_length[40]|xss_clean');
		$this->form_validation->set_rules('com_password', 'Confirm Password', 'trim|required|min_length[4]|max_length[40]|xss_clean');
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $status=1;            
            $message="somthing going worng";
            $email=$this->input->post('email');
		    $password=$this->input->post('password');
		    $com_password=$this->input->post('com_password');
           //check pasord are matched
            if($com_password==$password){
                $status=1;
                $message="passwords matched";
            }else{
                $status=0;
                $message="passwords not matched!";
            }
            //check alrady using username
            if($status==1)
            {
                $result = $this->User_Model->check_user($email);
                if($result==0)
                {
                    $status=1;
                    $message="User availble";
                }else{
                    $status=0;
                    $message="User alrady exist!";
                }
            }
            if($status==1)
            {
                $user_data=array('user_name'=>$email,'paswrd'=>$com_password);
                
                $result = $this->User_Model->save_user($user_data);
                if($result==0){
                    $status=0;
                    $message="Somthing worng while register user. please try again!";
                }else{
                    $user_id=$result;
                    $status=1;
                    $message="User availble"; 
                    $cus_code=$this->User_Model->gen_code('cus_id','customer','CUSWEB');                   
                    $customer_data=array('cus_email'=>$email,'reg_user_id'=>$result,'cus_type'=>'WEB');
                    $result = $this->User_Model->save_user_customer_profile($customer_data);
                    $cus_id=$result;
                    if($result==0){
                        $status=0;
                        $message="Somthing worng while register user. please try again!";
                    }else{
                        $status=1;
                        $message="customer profile saved";  
                        //CREATE TEMP USER LOGING
                        $the_session = array("site_user" =>  $user_id, "site_cus" => $cus_id, "login_type" => "temp", "cus_name" => $email);
                        $this -> session -> set_userdata($the_session);
                    }
                }
            }
            $st = array('status' =>$status,'message' => $message) ;
            echo json_encode($st);
        }
    }

    public function myAccount(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
        $data['target']=$this->input->get('target');
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        $data['cus_data'] = $this->User_Model->get_customer_details($cus_id); 
        $data['city_list'] = $this->User_Model->get_cities(); 
        $this->load->view('user/my-account' , $data);
    }

    public function accountUpdate() {
        $this->load->library('form_validation'); //form validation lib		
		//validations
		$this->form_validation->set_rules('cus_first_name', 'First Name', 'trim|required|min_length[2]|max_length[250]|xss_clean');
		$this->form_validation->set_rules('cus_last_name', 'Last Name', 'trim|required|min_length[2]|max_length[255]|xss_clean');
        $this->form_validation->set_rules('cus_m_phone', 'Mobile', 'trim|required|min_length[10]|max_length[10]|xss_clean');
        $this->form_validation->set_rules('cus_address', 'Address', 'trim|required|min_length[4]|max_length[500]|xss_clean');
        $this->form_validation->set_rules('city', 'City', 'trim|required|min_length[1]|max_length[10]|xss_clean');
        $this->form_validation->set_rules('cus_postal_code', 'ZIP code', 'trim|required|min_length[3]|max_length[10]|xss_clean');
        $this->form_validation->set_rules('target', 'Target', 'trim|xss_clean');        
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $status=1;            
            $message="somthing going worng";
            $target=$this->input->post('target');
            $target_status=0;
            $target_link="";
            if($target){
                $target_status=1;
                if($target=="checkout")
                {
                    $target_link="cart/checkOut"; 
                }
            }
            $cus_first_name=$this->input->post('cus_first_name');
		    $cus_last_name=$this->input->post('cus_last_name');
            $cus_m_phone=$this->input->post('cus_m_phone');
            $cus_address=$this->input->post('cus_address');
            $city=$this->input->post('city');
            $cus_postal_code=$this->input->post('cus_postal_code');
            $cus_m_phone=$this->input->post('cus_m_phone');  
            
            $customer_data=array(
                'cus_first_name'=>$cus_first_name,
                'cus_last_name'=>$cus_last_name,
                'cus_name'=>$cus_first_name.$cus_last_name,
                'cus_m_phone'=>$cus_m_phone,
                'cus_address'=>$cus_address,
                'city_id'=>$city,
                'cus_postal_code'=>$cus_postal_code,
                'cus_m_phone'=>$cus_m_phone,
            );
            $cus_id=$this -> session -> userdata('site_cus');

            if($cus_id>0){
                $result=$this->User_Model->update_customer($cus_id,$customer_data); 
                if($result==0){
                    $status=0;
                    $message="Somthing worng while register user. please try again!";
                }else{
                    $status=1;
                    $message="customer profile saved";                    
                }
            }else{
                $status=0;            
                $message="Logging Timeout. Please login again!";  
            }           
           
            $st = array('status' =>$status,'message' => $message,'target_status'=>$target_status , 'target_link'=>$target_link) ;
            echo json_encode($st);
        }
    }


    public function logOut()
    {
        $this->session->unset_userdata('site_cus');
        $this->session->sess_destroy();
        $status=1; $message="log Out";
        $st = array('status' =>$status,'message' => $message) ;
        echo json_encode($st);
    }

    public function dashbord(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id); 

        if($data['cus_data']['is_confirm']==1){
            $this->load->view('user/my-dashboard' , $data);
        }else{
            ob_start();
            header('Location: '.base_url('users/confirmAccount'));
            ob_end_flush();
            die();
        }    
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }      
    }


    public function confirmAccount(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $cusdata = $this->User_Model->get_customer_details($cus_id); 
            $confierm_code=mt_rand(100000, 999999);
            $user =$this->User_Model->get_user_id_by_cus_id_only($cus_id);
            $user_data=array(
                'comfirmation_code'=>$confierm_code,                       
            );
            $user_id=$user['reg_user_id'];
            $result=$this->User_Model->update_user($user_id,$user_data);
            $data['cus_data'] =$cusdata;
            //-------------------------------------------------
            $body                   =  'nnlkk';//$this->load->view('employer/employer_email/selected_mail', $data1, TRUE);
            $subject                = 'Jobspandora , Shortlisted';
            //$this->load->library('email');
            $config= array(
            'protocol' => 'mail',
            'smtp_host' => 'mail.siyallanka.com',
            'smtp_port' => 465,
            'smtp_user' => 'nonereply@siyallanka.com',
            'smtp_pass' => 'Demo123456789**',
            'mailtype' => 'text', 
            'smtp_timeout' => '10', 
            'charset' => 'iso-8859-1',
            'wordwrap' => TRUE
            );
           // $this->load->library('email', $config);
           // $this->email->initialize($config);
           $this->load->library('email');
            $this->email->initialize($config);
            $message = 'You Have Shortlisted by';
            $this->email->set_newline('\r\n');
            $this->email->from('noreply.siyallanka.com'); // change it to yours
            $this->email->to('m.m.sachitheranga@gmail.com'); // change it to yours
            $this->email->subject($subject);
            //$this->email->set_mailtype("text");
            $this->email->message($body);
            $responce =$this->email->send();
            //print_r($responce );
            if ($responce) {
                $email_status = 1;
                //echo "email sent";
            } else {
                $email_status = 0;
                print_r($this->email->print_debugger());  
            }
            $this->load->view('user/my-account-confirm' , $data);
            //-------------------------------------------------        
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }
           
    }

    public function login() {
        $this->load->library('form_validation'); //form validation lib		
		//validations
		$this->form_validation->set_rules('username', 'User Name or E-mail', 'trim|required|min_length[4]|max_length[40]|xss_clean');
		$this->form_validation->set_rules('password', 'Password', 'trim|required|min_length[4]|max_length[40]|xss_clean');
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $status=1;            
            $message="somthing going worng";
            $email=$this->input->post('username');
            $password=$this->input->post('password');
            $destination=$this->input->get('destination');
            //check alrady using username
            $goto='users/myOrders';
            if($status==1)
            {
                $result = $this->User_Model->check_user_password($email,$password);
                if($result==1)
                {
                    $status=1;
                    $message="User availble";
                    $user_data=$this->User_Model->get_user_details($email,$password);
                    $the_session = array("site_user" =>  $user_data['reg_user_id'], "site_cus" => $user_data['cus_id'], "login_type" => "full", "cus_name" => $user_data['cus_first_name']);
                    $this -> session -> set_userdata($the_session);
                    
                    if($destination=="check-out")
                    {
                        $goto='users/checkOut';
                    }
                }else{
                    $status=0;
                    $message="Login credentials not found";
                }
            }           
            $st = array('status' =>$status,'message' => $message,'dest' => $goto,) ;
            echo json_encode($st);
        }
    }

    public function myOrders(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);        
            $data['order_list'] = $this->User_Model->get_order_list($cus_id);
        if($data['cus_data']['is_confirm']==1){
            $this->load->view('user/my-orders' , $data); 
        }else{
            ob_start();
            header('Location: '.base_url('users/confirmAccount'));
            ob_end_flush();
            die();
        }    
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }
        //----------------------------------------
        
       
    }

    public function myAddress(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);        
        $this->load->view('user/my-addresses' , $data);
    }

    public function myAccountSettings(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);        
            $this->load->view('user/my-account-settings' , $data);        
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();
        }        
    }

    public function myChangePassword(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);        
            $this->load->view('user/my-change-password' , $data);       
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();
        }             
        
    }

    public function trackMyOrders(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);  
        $data['order_list'] = $this->User_Model->get_order_list_all($cus_id);       
        $this->load->view('user/track-your-order' , $data);
    }


    public function myOrderHistory(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);        
            $data['order_list'] = $this->User_Model->get_completed_order_list($cus_id);
        if($data['cus_data']['is_confirm']==1){
            $this->load->view('user/my-orders' , $data); 
        }else{
            ob_start();
            header('Location: '.base_url('users/confirmAccount'));
            ob_end_flush();
            die();
        }    
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }
        //----------------------------------------
        $cus_id=$this -> session -> userdata('site_cus');
       
    }
    //----------------------------------------------------------

    public function accountDelete() {
        $this->load->library('form_validation'); //form validation lib		
		//validations
		$this->form_validation->set_rules('password', 'Currant Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		$this->form_validation->set_rules('confirm_password', 'Confirm Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
       
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $cus_id=$this -> session -> userdata('site_cus');
            $status=1;            
            $message="somthing going worng";
            $password=$this->input->post('password');
            $confirm_password=$this->input->post('confirm_password');
            if($password!=$confirm_password){$status=0; $message="Password and confirm password dose not matched"; }
            else{
                $result =$this->User_Model->check_cus_password($cus_id,$password);
                if($result==1){
                    $status=1; $message="password is correct";
                    $user =$this->User_Model->get_user_id_by_cus_id($cus_id,$password);
                    $user_data=array(
                        'is_deleted'=>1,                
                    );
                    $user_id=$user['reg_user_id'];
                    $result=$this->User_Model->update_user($user_id,$user_data);
                    if($result==1){
                        $status=1; $message="Account successfully deleted";
                        $this->session->unset_userdata('site_cus');
                        $this->session->sess_destroy();
                    }else{
                        $status=0; $message="Somthing going worng while deleting your account ";
                    }
                }else{
                    $status=0; $message="Incorrect Password";
                }
            }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message) ;
            echo json_encode($st);
        }
    }

    //----------------------------------------------------

    public function updatePassword() {
        $this->load->library('form_validation'); //form validation lib		
        //validations
        $this->form_validation->set_rules('password-old', 'Old Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		$this->form_validation->set_rules('password', 'New Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		$this->form_validation->set_rules('confirm_password', 'New Confirm Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
       
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $cus_id=$this -> session -> userdata('site_cus');
            $status=1;            
            $message="somthing going worng";
            $password_old=$this->input->post('password-old');
            $password=$this->input->post('password');
            $confirm_password=$this->input->post('confirm_password');
            if($password!=$confirm_password){$status=0; $message="Password and confirm password dose not matched"; }
            else{
                $result =$this->User_Model->check_cus_password($cus_id,$password_old);
                if($result==1){
                    $status=1; $message="password is correct";
                    $user =$this->User_Model->get_user_id_by_cus_id($cus_id,$password_old);
                    $user_data=array(
                        'paswrd'=>$confirm_password,
                        'last_modified_date_time'=> date("Y-m-d H:i:s")           
                    );
                    $user_id=$user['reg_user_id'];
                    $result=$this->User_Model->update_user($user_id,$user_data);
                    if($result==1){
                        $status=1; $message="Password successfully Updated";
                       
                    }else{
                        $status=0; $message="Somthing going worng while Update pasword in your account ";
                    }
                }else{
                    $status=0; $message="Incorrect Password";
                }
            }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message) ;
            echo json_encode($st);
        }
    }



    public function myWishList(){
        //commmon set
        $bodyClass = "page-template-default page woocommerce-wishlist can-uppercase";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set 
        // added set  
        $cus_id=$this -> session -> userdata('site_cus');
        if(isset($cus_id)){
            $data['cus_data'] = $this->User_Model->get_customer_details($cus_id);  
            $wishlist_item= $this->User_Model->get_wishlist_item($cus_id);   
            $data['wishlist_item'] = $this->product_model->get_muliti_product($wishlist_item);  

                      
        if($data['cus_data']['is_confirm']==1){
            $this->load->view('user/wishlist' , $data); 
        }else{
            ob_start();
            header('Location: '.base_url('users/confirmAccount'));
            ob_end_flush();
            die();
        }    
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }
        //----------------------------------------
    }

    public function addToWithlist() {
        $product_id = $this->input->post('pro_id');
        $cus_id=$this -> session -> userdata('site_cus');

        if($cus_id){
            $user_data = array(
                'product_id' => $product_id,
                'cus_id' => $cus_id,                
            );
            $result=$this->User_Model->insert_wishlist($user_data);
            if($result==1){
                $data['message']="Product successfully Added";
                $data['status']=1;
               
            }else{
                $data['message']="Somthing going worng while Update product in your wishlist";
                $data['status']=0;
            }
        }else{
            $data['message'] = "Please logging first";
            $data['status']=0;
        }         
		echo json_encode($data);
    }


    public function removeWithlist() {
        $product_id = $this->input->post('pro_id');
        $cus_id=$this -> session -> userdata('site_cus');

        if($cus_id){           
            $result=$this->User_Model->remove_wishlist($cus_id,$product_id);
            if($result==1){
                $data['message']="Product successfully Removed";
                $data['status']=1;
               
            }else{
                $data['message']="Somthing going worng while Update product in your wishlist";
                $data['status']=0;
            }
        }else{
            $data['message'] = "Please logging first";
            $data['status']=0;
        }         
		echo json_encode($data);
    }



      //----------------------------------------------------

      public function confirmUser() {
        $this->load->library('form_validation'); //form validation lib		
        //validations
        $this->form_validation->set_rules('code', 'Confirmation Code', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {
            $cus_id=$this -> session -> userdata('site_cus');
            $status=1;            
            $message="somthing going worng";
            $code=$this->input->post('code');          
           
                $result =$this->User_Model->check_code($cus_id,$code);
                if($result==1){
                    $status=1; $message="password is correct";
                    $user =$this->User_Model->get_user_id_by_cus_id_only($cus_id);
                    $user_data=array(
                        'is_confirm'=>1,
                        'last_modified_date_time'=> date("Y-m-d H:i:s")  ,
                        'last_modify_by'=> $user['reg_user_id']        
                    );
                    $user_id=$user['reg_user_id'];
                    $result=$this->User_Model->update_user($user_id,$user_data);
                    if($result==1){
                        $status=1; $message="Successfully Updated";
                       
                    }else{
                        $status=0; $message="Somthing going worng while confirm in your account ";
                    }
              
            }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message) ;
            echo json_encode($st);
        }
    }

    //-------------------------------------------------------------

    public function lostPassword(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set  forgot-password        
        $this->load->view('user/forgot-password' , $data);
    }

    public function findMyAccount() {
        $this->load->library('form_validation'); //form validation lib		
        //validations
        $this->form_validation->set_rules('email', 'Email', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {        
            $status=1;            
            $message="somthing going worng";
            $email=$this->input->post('email');          
           
                $result =$this->User_Model->check_user($email);
                if($result==1){
                    $status=1; $message="Account Found"; 
                }else{
                    $status=0; $message="Account Not Found";  
                }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message,'user_name'=>$email) ;
            echo json_encode($st);
        }
    }

    public function resetPasswordMyAccount(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        // added set 
        
        $email=$this->input->get('usname'); 
        $data['username']=$email;
        $cus_dt = $this->User_Model->get_cus_id_using_username($email);
        $cus_id=$cus_dt['cus_id'];
        if(isset($cus_id)){
            $cusdata = $this->User_Model->get_customer_details($cus_id); 
            $confierm_code=mt_rand(100000, 999999);
            $user =$this->User_Model->get_user_id_by_cus_id_only($cus_id);
            $user_data=array(
                'comfirmation_code'=>$confierm_code,                       
            );
            $user_id=$user['reg_user_id'];
            $result=$this->User_Model->update_user($user_id,$user_data);
            $data['cus_data'] =$cusdata;
            //-------------------------------------------------
            $body                   =  'nnlkk';//$this->load->view('employer/employer_email/selected_mail', $data1, TRUE);
            $subject                = 'Jobspandora , Shortlisted';
            //$this->load->library('email');
            $config= array(
            'protocol' => 'mail',
            'smtp_host' => 'mail.siyallanka.com',
            'smtp_port' => 465,
            'smtp_user' => 'nonereply@siyallanka.com',
            'smtp_pass' => 'Demo123456789**',
            'mailtype' => 'text', 
            'smtp_timeout' => '10', 
            'charset' => 'iso-8859-1',
            'wordwrap' => TRUE
            );
           // $this->load->library('email', $config);
           // $this->email->initialize($config);
           $this->load->library('email');
            $this->email->initialize($config);
            $message = 'You Have Shortlisted by';
            $this->email->set_newline('\r\n');
            $this->email->from('noreply.siyallanka.com'); // change it to yours
            $this->email->to('m.m.sachitheranga@gmail.com'); // change it to yours
            $this->email->subject($subject);
            //$this->email->set_mailtype("text");
            $this->email->message($body);
            $responce =$this->email->send();
            //print_r($responce );
            if ($responce) {
                $email_status = 1;
                //echo "email sent";
            } else {
                $email_status = 0;
                print_r($this->email->print_debugger());  
            }
            $this->load->view('user/password-reset-confirm' , $data);
            //-------------------------------------------------        
        }else
        {
            ob_start();
            header('Location: '.base_url('users/userLoginSingup'));
            ob_end_flush();
            die();


        }
           
    }

    public function accountVerify() {
        $this->load->library('form_validation'); //form validation lib		
        //validations
        $this->form_validation->set_rules('email', 'Email', 'trim|required|min_length[4]|max_length[100]|xss_clean');
        $this->form_validation->set_rules('code', 'Confirm Code', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {      

            $status=1;            
            $message="somthing going worng";
            $email=$this->input->post('email');
            $code=$this->input->post('code');          
           
                $result =$this->User_Model->check_confirmation_code($email,$code);
                if($result==1){
                    $status=1; $message="OK"; 
                }else{
                    $status=0; $message="Invalid";  
                }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message,'user_name'=>$email,'email'=>$email,'code'=>$code) ;
            echo json_encode($st);
        }
    }

    public function updateNewPassword(){
        //commmon set
        $bodyClass = "my-account woocommerce-active left-sidebar";
		$data['bodyClass'] =$bodyClass;
        $data['cart'] = $this->cart->contents();
		$data['cart_count'] =count($data['cart'] );
		$data['cart_total'] = $this->cart->total();
        $data['sub_category_list'] = $this->Home_Model->get_sub_category_for_homepage();
        $data['category_list'] = $this->Home_Model->get_category_for_homepage(); 
        $data['username'] = '';
        $data['code'] = '';
        $email=$this->input->get('email');    
        $code=$this->input->get('code'); 
        $data['username'] = $email;
        $data['code'] =$code;
        // added set  forgot-password        
        $this->load->view('user/password-reset' , $data);
    }
    
    public function changeNewPassword() {
        $this->load->library('form_validation'); //form validation lib		
        //validations
        $this->form_validation->set_rules('email', 'Email', 'trim|required|min_length[4]|max_length[100]|xss_clean');
        $this->form_validation->set_rules('code', 'Code', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		$this->form_validation->set_rules('password', 'New Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
		$this->form_validation->set_rules('confirm_password', 'New Confirm Password', 'trim|required|min_length[4]|max_length[100]|xss_clean');
       
		//check validation	
		 if ($this->form_validation->run() == FALSE)
        {
           $st = array('status' =>0,'message' => validation_errors());
           echo json_encode($st);
        }
        else
        {         
            $status=1;            
            $message="somthing going worng";
            $email=$this->input->post('email');
            $code=$this->input->post('code');
            $password=$this->input->post('password');
            $confirm_password=$this->input->post('confirm_password');
            if($password!=$confirm_password){$status=0; $message="Password and confirm password dose not matched"; }
            else{
                $result =$this->User_Model->check_confirmation_code($email,$code);
                if($result==1){
                    $status=1; $message="Account Found";
                    $user = $this->User_Model->get_cus_id_using_username($email);
                    $user_data=array(
                        'paswrd'=>$confirm_password,
                        'last_modified_date_time'=> date("Y-m-d H:i:s")           
                    );
                    $user_id=$user['reg_user_id'];
                    $result=$this->User_Model->update_user($user_id,$user_data);
                    if($result==1){
                        $status=1; $message="Password successfully Updated";
                       
                    }else{
                        $status=0; $message="Somthing going worng while Update pasword in your account ";
                    }
                }else{
                    $status=0; $message="Incorrect Password";
                }
            }
            //------------------------------------           
            $st = array('status' =>$status,'message' => $message) ;
            echo json_encode($st);
        }
    }

   

}
